module CyberCoach
  #
  # Raised when a response is unsuccessful.
  #
  class HttpError < RuntimeError
    #
    # The response that caused it.
    #
    attr_accessor :cause

    #
    # Creates a HttpError.
    # cause:: The response that caused it.
    #
    def initialize(cause)
      super
      @cause = cause
    end

    #
    # Returns a string representation including the cause's header and body.
    #
    def to_s
      "#{super}\n\t#{@cause.to_hash}\n\t#{@cause.body}"
    end
  end
end
